NET.addAssembly('C:\Program Files\Analog Devices\ACE\Client\AnalogDevices.Csa.Remoting.Clients.dll');

% Copyright (c) 2019 Analog Devices, Inc.  All Rights Reserved. This software is proprietary to Analog Devices, ##Inc. and its licensors.
% These code snippets are provided ‘as is’ with no warranties, guarantees of suitability, or acceptance of any ## ## liability, for their use.

import AnalogDevices.Csa.Remoting.Clients.*;

manager = ClientManager.Create();
client = manager.CreateRequestClient(2357);

%AD7606C Configuration:
mode='True';                %True=Software mode; False=Hardware mode
range=3;                    %range=3-->+/-10V Single Ended Range
ref_sel='False';   %True= Internal Reference; False = External reference
par_serb='False';           %True=Parallel Interface; False = Serial Interface
throughput=4;               %kSPS
OSR=0;                      %Oversampling Ratio

for OSR=0:8

    configure_ad7606c(client, mode, range, par_serb, ref_sel, throughput, OSR);
    client.ContextPath = '\System\Subsystem_1\AD7606C-18 Board\AD7606C-18';
    DataSet = "DataSet_1";
    client.Run('@AsyncDataCapture(DataSet_1)');
    pause(10)
    client.PullAllCaptureDataToStore('-1', '2000', 'False', 'True', 'DataSet_1', 'Root::System.Subsystem_1.AD7606C-18 Board.AD7606C-18.AD7606C-18 Analysis', 'None');
end

% client.CloseSession();

function configure_ad7606c(client, mode, range, par_serb, ref_sel, throughput, OSR)
    % UI.SelectTab(Root::System.Subsystem_1.AD7606C-18 Board.AD7606C-18.AD7606C-18 Analysis);
    client.ContextPath = '\System\Subsystem_1\AD7606C-18 Board\AD7606C-18';
    client.SetBoolParameter('virtual-parameter-mode', mode, '-1');
    client.NavigateToPath('Root::System.Subsystem_1.AD7606C-18 Board.AD7606C-18');
    client.SetIntParameter('virtual-parameter-channel1_range_sw', num2str(range), '-1');
    client.SetIntParameter('virtual-parameter-channel2_range_sw', num2str(range), '-1');
    client.SetIntParameter('virtual-parameter-channel3_range_sw', num2str(range), '-1');
    client.SetIntParameter('virtual-parameter-channel4_range_sw', num2str(range), '-1');
    client.SetIntParameter('virtual-parameter-channel5_range_sw', num2str(range), '-1');
    client.SetIntParameter('virtual-parameter-channel6_range_sw', num2str(range), '-1');
    client.SetIntParameter('virtual-parameter-channel7_range_sw', num2str(range), '-1');
    client.SetIntParameter('virtual-parameter-channel8_range_sw', num2str(range), '-1');
    client.SetBoolParameter('virtual-parameter-par_serb', par_serb, '-1');
    client.SetBoolParameter('virtual-parameter-reference_select', ref_sel, '-1');
    client.SetDoubleParameter('virtual-parameter-throughput_display', num2str(throughput), '-1');
    client.SetIntParameter('virtual-parameter-os_sw', num2str(OSR), '-1');
    client.Run('@ApplySettings');
    % UI.SelectTab(tool.macrorecorder);
end
